import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { GoodsCategory, GoodsCategoryParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品分类
 */
export async function pageGoodsCategory(params: GoodsCategoryParam) {
  const res = await request.get<ApiResult<PageResult<GoodsCategory>>>(
    MODULES_API_URL + '/shop/goods-category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品分类列表
 */
export async function listGoodsCategory(params?: GoodsCategoryParam) {
  const res = await request.get<ApiResult<GoodsCategory[]>>(
    MODULES_API_URL + '/shop/goods-category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品分类
 */
export async function addGoodsCategory(data: GoodsCategory) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品分类
 */
export async function updateGoodsCategory(data: GoodsCategory) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品分类
 */
export async function removeGoodsCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品分类
 */
export async function removeBatchGoodsCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品分类
 */
export async function getGoodsCategory(id: number) {
  const res = await request.get<ApiResult<GoodsCategory>>(
    MODULES_API_URL + '/shop/goods-category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
